using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using EPiServer;
using EPiServer.Core;
using EPiServer.Web;
using EPiServer.Web.WebControls;
using EPiServer.Templates.Models.Blocks;
using System.Linq;
using System.Xml.Linq;
using System.Collections.Generic;

namespace EPiServer.Templates.Views.Blocks
{
    public partial class RssReaderBlockControl : BlockControlBase<RssReaderBlock>
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            XDocument rssDocument;
            try
            {
                if ((CurrentBlock.RssUrl != null) && (!CurrentBlock.RssUrl.IsEmpty()))
                {
                    rssDocument = XDocument.Load(Convert.ToString(CurrentBlock.RssUrl));

                    var posts = from item in rssDocument.Descendants("item").Take(CurrentBlock.MaxCount)
                                select new
                                {
                                    Title = item.Element("title").Value,
                                    Url = item.Element("link").Value,
                                    PublishDate = item.Element("pubDate").Value,
                                };

                    RssListView.DataSource = posts;
                    RssListView.DataBind();

                    if(HasHeadingText)
                        HeadingPlaceholder.Visible = true;
                }
            }
            catch (System.Net.WebException)
            {
                
            }
            catch (System.IO.FileNotFoundException)
            {
                
            }
        }

        public bool HasHeadingText
        {
            get { return ((!string.IsNullOrEmpty(CurrentBlock.Heading)) || ((CurrentBlock.DescriptiveText != null) && (!CurrentBlock.DescriptiveText.IsEmpty))); }
        }
    }
}